package cn.com.qmth.examcloud.core.reports.service.impl;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.stereotype.Service;

import cn.com.qmth.examcloud.core.reports.api.request.AddOrUpdateExamStudentCountReq;
import cn.com.qmth.examcloud.core.reports.dao.ExamStudentCountRepo;
import cn.com.qmth.examcloud.core.reports.dao.entity.ExamStudentCountEntity;
import cn.com.qmth.examcloud.core.reports.service.ExamStudentCountService;

@Service
public class ExamStudentCountServiceImpl implements ExamStudentCountService {
	@Autowired
	private ExamStudentCountRepo examStudentCountRepo;
	@Autowired
	private JdbcTemplate jdbcTemplate;

	@Override
	public void addOrUpdateCount(AddOrUpdateExamStudentCountReq req) {
		ExamStudentCountEntity e = examStudentCountRepo.findByRootOrgIdAndOrgIdAndExamId(req.getRootOrgId(),
				req.getOrgId(), req.getExamId());
		if (e == null) {
			e = new ExamStudentCountEntity();
			e.setRootOrgId(req.getRootOrgId());
			e.setOrgId(req.getOrgId());
			e.setExamId(req.getExamId());
		}
		e.setBatchTime(req.getBatchTime());
		e.setOnlineCount(req.getOnlineCount());
		examStudentCountRepo.save(e);
	}

	@Override
	public Long getOnlineCount(Long rootOrgId, Long orgId, Long examId) {
		StringBuffer sb = new StringBuffer();
		sb.append(" select sum(t.online_count) from ec_r_exam_student_count t where t.root_org_id=").append(rootOrgId);
		sb.append(" and t.batch_time=(select f.batch_time from ec_r_exam_student_count f order by f.batch_time desc limit 1) ");
		if (orgId != null) {
			sb.append(" and t.org_id=").append(orgId);
		}
		if (examId != null) {
			sb.append(" and t.exam_id=").append(examId);
		}
		Long count = jdbcTemplate.queryForObject(sb.toString(), Long.class);
		if (count == null) {
			count = 0l;
		}
		return count;
	}
}
