package cn.com.qmth.examcloud.core.reports.service.impl;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.stereotype.Service;

import cn.com.qmth.examcloud.core.reports.api.request.AddOrUpdateUserCountReq;
import cn.com.qmth.examcloud.core.reports.dao.UserCountRepo;
import cn.com.qmth.examcloud.core.reports.dao.entity.UserCountEntity;
import cn.com.qmth.examcloud.core.reports.service.UserCountService;

@Service
public class UserCountServiceImpl implements UserCountService {
	@Autowired
	private UserCountRepo userCountRepo;
	@Autowired
	private JdbcTemplate jdbcTemplate;
	@Override
	public void addOrUpdateCount(AddOrUpdateUserCountReq req) {
		UserCountEntity e=userCountRepo.findByRootOrgIdAndOrgId(req.getRootOrgId(), req.getOrgId());
		if(e==null) {
			e=new UserCountEntity();
			e.setRootOrgId(req.getRootOrgId());
			e.setOrgId(req.getOrgId());
		}
		e.setBatchTime(req.getBatchTime());
		e.setOnlineCount(req.getOnlineCount());
		userCountRepo.save(e);
	}

	@Override
	public Long getOnlineCount(Long rootOrgId, Long orgId) {
		StringBuffer sb=new StringBuffer();
		sb.append(" select sum(t.online_count) from ec_r_user_count t where t.root_org_id=").append(rootOrgId);
		sb.append(" and t.batch_time=(select f.batch_time from ec_r_user_count f order by f.batch_time desc limit 1) ");
		if(orgId!=null) {
			sb.append(" and t.org_id=").append(orgId);
		}
		Long count=jdbcTemplate.queryForObject(sb.toString(), Long.class);
		if(count==null) {
			count=0l;
		}
		return count;
	}
}
